searchData={"items":[{"type":"module","title":"UniRecover","doc":"See `UniRecover.sub/3` for documentation.","ref":"UniRecover.html"},{"type":"function","title":"UniRecover.sub/3","doc":"Substitutes all illegal sequences in the provided data with the Unicode [replacement character](https://en.wikipedia.org/wiki/Specials_(Unicode_block)#Replacement_character).","ref":"UniRecover.html#sub/3"},{"type":"extras","title":"A much improved version is available here: https://github.com/elixir-unicode/unicode","doc":"# A much improved version is available here: https://github.com/elixir-unicode/unicode\nSee `Unicode.replace_invalid/3`.\n\n# UniRecover\nA library for substituting illegal bytes in Unicode encoded data, following W3C spec as suggested by the [Unicode Standard](https://www.unicode.org/versions/Unicode15.0.0/UnicodeStandard-15.0.pdf#page=153).\n\nThis library leverages Erlang [Sub Binaries](https://www.erlang.org/doc/efficiency_guide/binaryhandling#sub-binaries) to scale well with large amounts of data. This should suffice for most use-cases, short of those that may necessitate NIF-based solutions.","ref":"readme.html"},{"type":"extras","title":"Installation - A much improved version is available here: https://github.com/elixir-unicode/unicode","doc":"Add `:uni_recover` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:uni_recover, \"~> 0.1.2\"}\n  ]\nend\n```\n\nDocumentation is available on [HexDocs](https://hexdocs.pm/uni_recover/readme.html) and may also be generated with [ExDoc](https://github.com/elixir-lang/ex_doc).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - A much improved version is available here: https://github.com/elixir-unicode/unicode","doc":"```elixir\n# 0b11111111 = an illegal utf-8 code sequence\nUniRecover.sub( >)\n# \"foo�bar\"\n\n# 216, 0 = an illegal utf-16 code sequence\n(UniRecover.sub( >, :utf16)\n|> :unicode.characters_to_binary(:utf16))\n# \"foo�bar\"\n```","ref":"readme.html#usage"},{"type":"extras","title":"Benchmarking - A much improved version is available here: https://github.com/elixir-unicode/unicode","doc":"The following benchmark demonstrates how UniRecover leverages sub binaries, only allocating the indexes of illegal bytes. See the benchmarking folder in the repo for details.\n\n```\nName                                  ips        average  deviation         median         99th %\nUniRecover, 207KB Input           1842.84      542.64 μs     ±1.44%      539.67 μs      574.71 μs\nSimple Rebuild, 207KB Input        172.02     5813.34 μs    ±13.88%     5534.29 μs     8223.92 μs\nNaive 3-liner, 207KB Input          56.59    17670.58 μs     ±6.44%    17377.60 μs    19210.26 μs\n\nComparison: \nUniRecover, 207KB Input           1842.84\nSimple Rebuild, 207KB Input        172.02 - 10.71x slower +5270.70 μs\nNaive 3-liner, 207KB Input          56.59 - 32.56x slower +17127.94 μs\n\nMemory usage statistics:\n\nName                           Memory usage\nUniRecover, 207KB Input               296 B\nSimple Rebuild, 207KB Input       8215208 B - 27754.08x memory usage +8214912 B\nNaive 3-liner, 207KB Input       39556040 B - 133635.27x memory usage +39555744 B\n```\n\nFor reference, the `Simple` implementation allocated 39.66x the original json, and `Naive` even worse at a whopping 191x the original.","ref":"readme.html#benchmarking"}],"content_type":"text/markdown"}